## Federated Learning for NLP
This list is constantly being updated. Feel free to contribute!


### 2022
| Title | Venue | Link | 
| --- | --- | --- | 
| FedBERT: When Federated Learning Meets Pre-Training | TIST | [pdf](https://dl.acm.org/doi/pdf/10.1145/3510033) |
| FedKC: Federated Knowledge Composition for Multilingual Natural Language Understanding | WWW | [pdf](https://dl.acm.org/doi/pdf/10.1145/3485447.3511988) |


### 2021
| Title | Venue | Link | 
| --- | --- | --- | 
| FedMatch: Federated Learning Over Heterogeneous Question Answering Data | CIKM | [pdf](https://dl.acm.org/doi/pdf/10.1145/3459637.3482345), [code](https://github.com/Chriskuei/FedMatch) |
| Federated Chinese Word Segmentation with Global Character Associations | ACL | [pdf](https://aclanthology.org/2021.findings-acl.376.pdf), [code](https://github.com/cuhksz-nlp/GCASeg) |
| Improving Federated Learning for Aspect-based Sentiment Analysis via Topic Memories | EMNLP | [pdf](https://aclanthology.org/2021.emnlp-main.321.pdf), [code](https://github.com/cuhksz-nlp/ASA-TM) |
| A Secure and Efficient Federated Learning Framework for NLP | EMNLP | [pdf](https://aclanthology.org/2021.emnlp-main.606.pdf) |
| Distantly Supervised Relation Extraction in Federated Settings | EMNLP | [pdf](https://aclanthology.org/2021.findings-emnlp.52.pdf), [code](https://github.com/DianboWork/FedDS) |
| FedNLP: Benchmarking Federated Learning Methods for Natural Language Processing Tasks | arXiv | [pdf](https://arxiv.org/pdf/2104.08815.pdf), [code](https://github.com/FedML-AI/FedNLP) |
| Scaling Federated Learning for Fine-tuning of Large Language Models | arXiv | [pdf](https://arxiv.org/pdf/2102.00875.pdf) |


### 2020
| Title | Venue | Link | 
| --- | --- | --- | 
| Empirical Studies of Institutional Federated Learning For Natural Language Processing | EMNLP | [pdf](https://aclanthology.org/2020.findings-emnlp.55.pdf) |
| FedED: Federated Learning via Ensemble Distillation for Medical Relation Extraction | EMNLP | [pdf](https://aclanthology.org/2020.emnlp-main.165.pdf) |
| FedNER: Privacy-preserving Medical Named Entity Recognition with Federated Learning | arXiv | [pdf](https://arxiv.org/pdf/2003.09288.pdf) |
| Federated Pretraining and Fine Tuning of BERT Using Clinical Notes from Multiple Silos | arXiv | [pdf](https://arxiv.org/pdf/2002.08562.pdf) |
| Pretraining Federated Text Models for Next Word Prediction | arXiv | [pdf](https://arxiv.org/pdf/2005.04828.pdf), [code](https://github.com/federated-learning-experiments/fl-text-models) |


### 2019
| Title | Venue | Link | 
| --- | --- | --- | 
| Federated Learning of N-gram Language Models | CoNLL | [pdf](https://arxiv.org/pdf/1910.03432.pdf) |
| Learning Private Neural Language Modeling with Attentive Aggregation | IJCNN | [pdf](https://arxiv.org/pdf/1812.07108.pdf) |
| Federated Learning Of Out-Of-Vocabulary Words | arXiv | [pdf](https://arxiv.org/pdf/1903.10635.pdf) |
| Federated Learning for Emoji Prediction in a Mobile Keyboard | arXiv | [pdf](https://arxiv.org/pdf/1906.04329.pdf) |


### 2018
| Title | Venue | Link |  
| --- | --- | --- | 
| Federated Learning for Mobile Keyboard Prediction | arXiv | [pdf](https://arxiv.org/pdf/1811.03604.pdf) |
| Applied Federated Learning: Improving Google Keyboard Query Suggestions | arXiv | [pdf](https://arxiv.org/pdf/1812.02903.pdf) |
